package net.minecraft.client.model;

import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.world.entity.Entity;
import net.neoforged.api.distmarker.Dist;
import net.neoforged.api.distmarker.OnlyIn;

@OnlyIn(Dist.CLIENT)
public class LlamaSpitModel<T extends Entity> extends HierarchicalModel<T> {
    private static final String MAIN = "main";
    private final ModelPart root;

    public LlamaSpitModel(ModelPart p_170730_) {
        this.root = p_170730_;
    }

    public static LayerDefinition createBodyLayer() {
        MeshDefinition meshdefinition = new MeshDefinition();
        PartDefinition partdefinition = meshdefinition.getRoot();
        int i = 2;
        partdefinition.addOrReplaceChild(
            "main",
            CubeListBuilder.create()
                .texOffs(0, 0)
                .addBox(-4.0F, 0.0F, 0.0F, 2.0F, 2.0F, 2.0F)
                .addBox(0.0F, -4.0F, 0.0F, 2.0F, 2.0F, 2.0F)
                .addBox(0.0F, 0.0F, -4.0F, 2.0F, 2.0F, 2.0F)
                .addBox(0.0F, 0.0F, 0.0F, 2.0F, 2.0F, 2.0F)
                .addBox(2.0F, 0.0F, 0.0F, 2.0F, 2.0F, 2.0F)
                .addBox(0.0F, 2.0F, 0.0F, 2.0F, 2.0F, 2.0F)
                .addBox(0.0F, 0.0F, 2.0F, 2.0F, 2.0F, 2.0F),
            PartPose.ZERO
        );
        return LayerDefinition.create(meshdefinition, 64, 32);
    }

    @Override
    public void setupAnim(T p_103090_, float p_103091_, float p_103092_, float p_103093_, float p_103094_, float p_103095_) {
    }

    @Override
    public ModelPart root() {
        return this.root;
    }
}
