package net.minecraft.commands;

import com.mojang.serialization.Codec;
import java.util.Optional;
import net.minecraft.commands.functions.CommandFunction;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.ServerFunctionManager;

public class CacheableFunction {
    public static final Codec<CacheableFunction> CODEC = ResourceLocation.CODEC.xmap(CacheableFunction::new, CacheableFunction::getId);
    private final ResourceLocation id;
    private boolean resolved;
    private Optional<CommandFunction<CommandSourceStack>> function = Optional.empty();

    public CacheableFunction(ResourceLocation p_305952_) {
        this.id = p_305952_;
    }

    public Optional<CommandFunction<CommandSourceStack>> get(ServerFunctionManager p_305905_) {
        if (!this.resolved) {
            this.function = p_305905_.get(this.id);
            this.resolved = true;
        }

        return this.function;
    }

    public ResourceLocation getId() {
        return this.id;
    }

    @Override
    public boolean equals(Object p_312197_) {
        if (p_312197_ == this) {
            return true;
        } else {
            if (p_312197_ instanceof CacheableFunction cacheablefunction && this.getId().equals(cacheablefunction.getId())) {
                return true;
            }

            return false;
        }
    }
}
