package net.minecraft.network.protocol.common;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.network.codec.StreamCodec;
import net.minecraft.network.protocol.Packet;
import net.minecraft.network.protocol.PacketType;

public class ClientboundPingPacket implements Packet<ClientCommonPacketListener> {
    public static final StreamCodec<FriendlyByteBuf, ClientboundPingPacket> STREAM_CODEC = Packet.codec(
        ClientboundPingPacket::write, ClientboundPingPacket::new
    );
    private final int id;

    public ClientboundPingPacket(int p_294778_) {
        this.id = p_294778_;
    }

    private ClientboundPingPacket(FriendlyByteBuf p_294565_) {
        this.id = p_294565_.readInt();
    }

    private void write(FriendlyByteBuf p_295570_) {
        p_295570_.writeInt(this.id);
    }

    @Override
    public PacketType<ClientboundPingPacket> type() {
        return CommonPacketTypes.CLIENTBOUND_PING;
    }

    public void handle(ClientCommonPacketListener p_295189_) {
        p_295189_.handlePing(this);
    }

    public int getId() {
        return this.id;
    }
}
