package net.minecraft.world.level.block;

import com.mojang.serialization.MapCodec;
import java.util.function.Function;
import net.minecraft.core.Registry;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.world.level.block.piston.MovingPistonBlock;
import net.minecraft.world.level.block.piston.PistonBaseBlock;
import net.minecraft.world.level.block.piston.PistonHeadBlock;

public class BlockTypes {
    public static final MapCodec<Block> CODEC = BuiltInRegistries.BLOCK_TYPE.byNameCodec().dispatchMap(Block::codec, Function.identity());

    public static MapCodec<? extends Block> bootstrap(Registry<MapCodec<? extends Block>> p_304881_) {
        Registry.register(p_304881_, "block", Block.CODEC);
        Registry.register(p_304881_, "air", AirBlock.CODEC);
        Registry.register(p_304881_, "amethyst", AmethystBlock.CODEC);
        Registry.register(p_304881_, "amethyst_cluster", AmethystClusterBlock.CODEC);
        Registry.register(p_304881_, "anvil", AnvilBlock.CODEC);
        Registry.register(p_304881_, "attached_stem", AttachedStemBlock.CODEC);
        Registry.register(p_304881_, "azalea", AzaleaBlock.CODEC);
        Registry.register(p_304881_, "bamboo_sapling", BambooSaplingBlock.CODEC);
        Registry.register(p_304881_, "bamboo_stalk", BambooStalkBlock.CODEC);
        Registry.register(p_304881_, "banner", BannerBlock.CODEC);
        Registry.register(p_304881_, "barrel", BarrelBlock.CODEC);
        Registry.register(p_304881_, "barrier", BarrierBlock.CODEC);
        Registry.register(p_304881_, "base_coral_fan", BaseCoralFanBlock.CODEC);
        Registry.register(p_304881_, "base_coral_plant", BaseCoralPlantBlock.CODEC);
        Registry.register(p_304881_, "base_coral_wall_fan", BaseCoralWallFanBlock.CODEC);
        Registry.register(p_304881_, "beacon", BeaconBlock.CODEC);
        Registry.register(p_304881_, "bed", BedBlock.CODEC);
        Registry.register(p_304881_, "beehive", BeehiveBlock.CODEC);
        Registry.register(p_304881_, "beetroot", BeetrootBlock.CODEC);
        Registry.register(p_304881_, "bell", BellBlock.CODEC);
        Registry.register(p_304881_, "big_dripleaf", BigDripleafBlock.CODEC);
        Registry.register(p_304881_, "big_dripleaf_stem", BigDripleafStemBlock.CODEC);
        Registry.register(p_304881_, "blast_furnace", BlastFurnaceBlock.CODEC);
        Registry.register(p_304881_, "brewing_stand", BrewingStandBlock.CODEC);
        Registry.register(p_304881_, "brushable", BrushableBlock.CODEC);
        Registry.register(p_304881_, "bubble_column", BubbleColumnBlock.CODEC);
        Registry.register(p_304881_, "budding_amethyst", BuddingAmethystBlock.CODEC);
        Registry.register(p_304881_, "button", ButtonBlock.CODEC);
        Registry.register(p_304881_, "cactus", CactusBlock.CODEC);
        Registry.register(p_304881_, "cake", CakeBlock.CODEC);
        Registry.register(p_304881_, "calibrated_sculk_sensor", CalibratedSculkSensorBlock.CODEC);
        Registry.register(p_304881_, "campfire", CampfireBlock.CODEC);
        Registry.register(p_304881_, "candle_cake", CandleCakeBlock.CODEC);
        Registry.register(p_304881_, "candle", CandleBlock.CODEC);
        Registry.register(p_304881_, "carpet", CarpetBlock.CODEC);
        Registry.register(p_304881_, "carrot", CarrotBlock.CODEC);
        Registry.register(p_304881_, "cartography_table", CartographyTableBlock.CODEC);
        Registry.register(p_304881_, "carved_pumpkin", EquipableCarvedPumpkinBlock.CODEC);
        Registry.register(p_304881_, "cauldron", CauldronBlock.CODEC);
        Registry.register(p_304881_, "cave_vines", CaveVinesBlock.CODEC);
        Registry.register(p_304881_, "cave_vines_plant", CaveVinesPlantBlock.CODEC);
        Registry.register(p_304881_, "ceiling_hanging_sign", CeilingHangingSignBlock.CODEC);
        Registry.register(p_304881_, "chain", ChainBlock.CODEC);
        Registry.register(p_304881_, "cherry_leaves", CherryLeavesBlock.CODEC);
        Registry.register(p_304881_, "chest", ChestBlock.CODEC);
        Registry.register(p_304881_, "chiseled_book_shelf", ChiseledBookShelfBlock.CODEC);
        Registry.register(p_304881_, "chorus_flower", ChorusFlowerBlock.CODEC);
        Registry.register(p_304881_, "chorus_plant", ChorusPlantBlock.CODEC);
        Registry.register(p_304881_, "cocoa", CocoaBlock.CODEC);
        Registry.register(p_304881_, "colored_falling", ColoredFallingBlock.CODEC);
        Registry.register(p_304881_, "command", CommandBlock.CODEC);
        Registry.register(p_304881_, "comparator", ComparatorBlock.CODEC);
        Registry.register(p_304881_, "composter", ComposterBlock.CODEC);
        Registry.register(p_304881_, "concrete_powder", ConcretePowderBlock.CODEC);
        Registry.register(p_304881_, "conduit", ConduitBlock.CODEC);
        Registry.register(p_304881_, "copper_bulb_block", CopperBulbBlock.CODEC);
        Registry.register(p_304881_, "coral", CoralBlock.CODEC);
        Registry.register(p_304881_, "coral_fan", CoralFanBlock.CODEC);
        Registry.register(p_304881_, "coral_plant", CoralPlantBlock.CODEC);
        Registry.register(p_304881_, "coral_wall_fan", CoralWallFanBlock.CODEC);
        Registry.register(p_304881_, "crafter", CrafterBlock.CODEC);
        Registry.register(p_304881_, "crafting_table", CraftingTableBlock.CODEC);
        Registry.register(p_304881_, "crop", CropBlock.CODEC);
        Registry.register(p_304881_, "crying_obsidian", CryingObsidianBlock.CODEC);
        Registry.register(p_304881_, "daylight_detector", DaylightDetectorBlock.CODEC);
        Registry.register(p_304881_, "dead_bush", DeadBushBlock.CODEC);
        Registry.register(p_304881_, "decorated_pot", DecoratedPotBlock.CODEC);
        Registry.register(p_304881_, "detector_rail", DetectorRailBlock.CODEC);
        Registry.register(p_304881_, "dirt_path", DirtPathBlock.CODEC);
        Registry.register(p_304881_, "dispenser", DispenserBlock.CODEC);
        Registry.register(p_304881_, "door", DoorBlock.CODEC);
        Registry.register(p_304881_, "double_plant", DoublePlantBlock.CODEC);
        Registry.register(p_304881_, "dragon_egg", DragonEggBlock.CODEC);
        Registry.register(p_304881_, "drop_experience", DropExperienceBlock.CODEC);
        Registry.register(p_304881_, "dropper", DropperBlock.CODEC);
        Registry.register(p_304881_, "enchantment_table", EnchantingTableBlock.CODEC);
        Registry.register(p_304881_, "ender_chest", EnderChestBlock.CODEC);
        Registry.register(p_304881_, "end_gateway", EndGatewayBlock.CODEC);
        Registry.register(p_304881_, "end_portal", EndPortalBlock.CODEC);
        Registry.register(p_304881_, "end_portal_frame", EndPortalFrameBlock.CODEC);
        Registry.register(p_304881_, "end_rod", EndRodBlock.CODEC);
        Registry.register(p_304881_, "farm", FarmBlock.CODEC);
        Registry.register(p_304881_, "fence", FenceBlock.CODEC);
        Registry.register(p_304881_, "fence_gate", FenceGateBlock.CODEC);
        Registry.register(p_304881_, "fire", FireBlock.CODEC);
        Registry.register(p_304881_, "fletching_table", FletchingTableBlock.CODEC);
        Registry.register(p_304881_, "flower", FlowerBlock.CODEC);
        Registry.register(p_304881_, "flower_pot", FlowerPotBlock.CODEC);
        Registry.register(p_304881_, "frogspawn", FrogspawnBlock.CODEC);
        Registry.register(p_304881_, "frosted_ice", FrostedIceBlock.CODEC);
        Registry.register(p_304881_, "fungus", FungusBlock.CODEC);
        Registry.register(p_304881_, "furnace", FurnaceBlock.CODEC);
        Registry.register(p_304881_, "glazed_terracotta", GlazedTerracottaBlock.CODEC);
        Registry.register(p_304881_, "glow_lichen", GlowLichenBlock.CODEC);
        Registry.register(p_304881_, "grass", GrassBlock.CODEC);
        Registry.register(p_304881_, "grindstone", GrindstoneBlock.CODEC);
        Registry.register(p_304881_, "half_transparent", HalfTransparentBlock.CODEC);
        Registry.register(p_304881_, "hanging_roots", HangingRootsBlock.CODEC);
        Registry.register(p_304881_, "hay", HayBlock.CODEC);
        Registry.register(p_304881_, "heavy_core", HeavyCoreBlock.CODEC);
        Registry.register(p_304881_, "honey", HoneyBlock.CODEC);
        Registry.register(p_304881_, "hopper", HopperBlock.CODEC);
        Registry.register(p_304881_, "huge_mushroom", HugeMushroomBlock.CODEC);
        Registry.register(p_304881_, "ice", IceBlock.CODEC);
        Registry.register(p_304881_, "infested", InfestedBlock.CODEC);
        Registry.register(p_304881_, "infested_rotated_pillar", InfestedRotatedPillarBlock.CODEC);
        Registry.register(p_304881_, "iron_bars", IronBarsBlock.CODEC);
        Registry.register(p_304881_, "jack_o_lantern", CarvedPumpkinBlock.CODEC);
        Registry.register(p_304881_, "jigsaw", JigsawBlock.CODEC);
        Registry.register(p_304881_, "jukebox", JukeboxBlock.CODEC);
        Registry.register(p_304881_, "kelp", KelpBlock.CODEC);
        Registry.register(p_304881_, "kelp_plant", KelpPlantBlock.CODEC);
        Registry.register(p_304881_, "ladder", LadderBlock.CODEC);
        Registry.register(p_304881_, "lantern", LanternBlock.CODEC);
        Registry.register(p_304881_, "lava_cauldron", LavaCauldronBlock.CODEC);
        Registry.register(p_304881_, "layered_cauldron", LayeredCauldronBlock.CODEC);
        Registry.register(p_304881_, "leaves", LeavesBlock.CODEC);
        Registry.register(p_304881_, "lectern", LecternBlock.CODEC);
        Registry.register(p_304881_, "lever", LeverBlock.CODEC);
        Registry.register(p_304881_, "light", LightBlock.CODEC);
        Registry.register(p_304881_, "lightning_rod", LightningRodBlock.CODEC);
        Registry.register(p_304881_, "liquid", LiquidBlock.CODEC);
        Registry.register(p_304881_, "loom", LoomBlock.CODEC);
        Registry.register(p_304881_, "magma", MagmaBlock.CODEC);
        Registry.register(p_304881_, "mangrove_leaves", MangroveLeavesBlock.CODEC);
        Registry.register(p_304881_, "mangrove_propagule", MangrovePropaguleBlock.CODEC);
        Registry.register(p_304881_, "mangrove_roots", MangroveRootsBlock.CODEC);
        Registry.register(p_304881_, "moss", MossBlock.CODEC);
        Registry.register(p_304881_, "moving_piston", MovingPistonBlock.CODEC);
        Registry.register(p_304881_, "mud", MudBlock.CODEC);
        Registry.register(p_304881_, "mushroom", MushroomBlock.CODEC);
        Registry.register(p_304881_, "mycelium", MyceliumBlock.CODEC);
        Registry.register(p_304881_, "nether_portal", NetherPortalBlock.CODEC);
        Registry.register(p_304881_, "netherrack", NetherrackBlock.CODEC);
        Registry.register(p_304881_, "nether_sprouts", NetherSproutsBlock.CODEC);
        Registry.register(p_304881_, "nether_wart", NetherWartBlock.CODEC);
        Registry.register(p_304881_, "note", NoteBlock.CODEC);
        Registry.register(p_304881_, "nylium", NyliumBlock.CODEC);
        Registry.register(p_304881_, "observer", ObserverBlock.CODEC);
        Registry.register(p_304881_, "piglinwallskull", PiglinWallSkullBlock.CODEC);
        Registry.register(p_304881_, "pink_petals", PinkPetalsBlock.CODEC);
        Registry.register(p_304881_, "piston_base", PistonBaseBlock.CODEC);
        Registry.register(p_304881_, "piston_head", PistonHeadBlock.CODEC);
        Registry.register(p_304881_, "pitcher_crop", PitcherCropBlock.CODEC);
        Registry.register(p_304881_, "player_head", PlayerHeadBlock.CODEC);
        Registry.register(p_304881_, "player_wall_head", PlayerWallHeadBlock.CODEC);
        Registry.register(p_304881_, "pointed_dripstone", PointedDripstoneBlock.CODEC);
        Registry.register(p_304881_, "potato", PotatoBlock.CODEC);
        Registry.register(p_304881_, "powder_snow", PowderSnowBlock.CODEC);
        Registry.register(p_304881_, "powered", PoweredBlock.CODEC);
        Registry.register(p_304881_, "powered_rail", PoweredRailBlock.CODEC);
        Registry.register(p_304881_, "pressure_plate", PressurePlateBlock.CODEC);
        Registry.register(p_304881_, "pumpkin", PumpkinBlock.CODEC);
        Registry.register(p_304881_, "rail", RailBlock.CODEC);
        Registry.register(p_304881_, "redstone_lamp", RedstoneLampBlock.CODEC);
        Registry.register(p_304881_, "redstone_ore", RedStoneOreBlock.CODEC);
        Registry.register(p_304881_, "redstone_torch", RedstoneTorchBlock.CODEC);
        Registry.register(p_304881_, "redstone_wall_torch", RedstoneWallTorchBlock.CODEC);
        Registry.register(p_304881_, "redstone_wire", RedStoneWireBlock.CODEC);
        Registry.register(p_304881_, "repeater", RepeaterBlock.CODEC);
        Registry.register(p_304881_, "respawn_anchor", RespawnAnchorBlock.CODEC);
        Registry.register(p_304881_, "rooted_dirt", RootedDirtBlock.CODEC);
        Registry.register(p_304881_, "roots", RootsBlock.CODEC);
        Registry.register(p_304881_, "rotated_pillar", RotatedPillarBlock.CODEC);
        Registry.register(p_304881_, "sapling", SaplingBlock.CODEC);
        Registry.register(p_304881_, "scaffolding", ScaffoldingBlock.CODEC);
        Registry.register(p_304881_, "sculk_catalyst", SculkCatalystBlock.CODEC);
        Registry.register(p_304881_, "sculk", SculkBlock.CODEC);
        Registry.register(p_304881_, "sculk_sensor", SculkSensorBlock.CODEC);
        Registry.register(p_304881_, "sculk_shrieker", SculkShriekerBlock.CODEC);
        Registry.register(p_304881_, "sculk_vein", SculkVeinBlock.CODEC);
        Registry.register(p_304881_, "seagrass", SeagrassBlock.CODEC);
        Registry.register(p_304881_, "sea_pickle", SeaPickleBlock.CODEC);
        Registry.register(p_304881_, "shulker_box", ShulkerBoxBlock.CODEC);
        Registry.register(p_304881_, "skull", SkullBlock.CODEC);
        Registry.register(p_304881_, "slab", SlabBlock.CODEC);
        Registry.register(p_304881_, "slime", SlimeBlock.CODEC);
        Registry.register(p_304881_, "small_dripleaf", SmallDripleafBlock.CODEC);
        Registry.register(p_304881_, "smithing_table", SmithingTableBlock.CODEC);
        Registry.register(p_304881_, "smoker", SmokerBlock.CODEC);
        Registry.register(p_304881_, "sniffer_egg", SnifferEggBlock.CODEC);
        Registry.register(p_304881_, "snow_layer", SnowLayerBlock.CODEC);
        Registry.register(p_304881_, "snowy_dirt", SnowyDirtBlock.CODEC);
        Registry.register(p_304881_, "soul_fire", SoulFireBlock.CODEC);
        Registry.register(p_304881_, "soul_sand", SoulSandBlock.CODEC);
        Registry.register(p_304881_, "spawner", SpawnerBlock.CODEC);
        Registry.register(p_304881_, "sponge", SpongeBlock.CODEC);
        Registry.register(p_304881_, "spore_blossom", SporeBlossomBlock.CODEC);
        Registry.register(p_304881_, "stained_glass_pane", StainedGlassPaneBlock.CODEC);
        Registry.register(p_304881_, "stained_glass", StainedGlassBlock.CODEC);
        Registry.register(p_304881_, "stair", StairBlock.CODEC);
        Registry.register(p_304881_, "standing_sign", StandingSignBlock.CODEC);
        Registry.register(p_304881_, "stem", StemBlock.CODEC);
        Registry.register(p_304881_, "stonecutter", StonecutterBlock.CODEC);
        Registry.register(p_304881_, "structure", StructureBlock.CODEC);
        Registry.register(p_304881_, "structure_void", StructureVoidBlock.CODEC);
        Registry.register(p_304881_, "sugar_cane", SugarCaneBlock.CODEC);
        Registry.register(p_304881_, "sweet_berry_bush", SweetBerryBushBlock.CODEC);
        Registry.register(p_304881_, "tall_flower", TallFlowerBlock.CODEC);
        Registry.register(p_304881_, "tall_grass", TallGrassBlock.CODEC);
        Registry.register(p_304881_, "tall_seagrass", TallSeagrassBlock.CODEC);
        Registry.register(p_304881_, "target", TargetBlock.CODEC);
        Registry.register(p_304881_, "tinted_glass", TintedGlassBlock.CODEC);
        Registry.register(p_304881_, "tnt", TntBlock.CODEC);
        Registry.register(p_304881_, "torchflower_crop", TorchflowerCropBlock.CODEC);
        Registry.register(p_304881_, "torch", TorchBlock.CODEC);
        Registry.register(p_304881_, "transparent", TransparentBlock.CODEC);
        Registry.register(p_304881_, "trapdoor", TrapDoorBlock.CODEC);
        Registry.register(p_304881_, "trapped_chest", TrappedChestBlock.CODEC);
        Registry.register(p_304881_, "trial_spawner", TrialSpawnerBlock.CODEC);
        Registry.register(p_304881_, "trip_wire_hook", TripWireHookBlock.CODEC);
        Registry.register(p_304881_, "tripwire", TripWireBlock.CODEC);
        Registry.register(p_304881_, "turtle_egg", TurtleEggBlock.CODEC);
        Registry.register(p_304881_, "twisting_vines_plant", TwistingVinesPlantBlock.CODEC);
        Registry.register(p_304881_, "twisting_vines", TwistingVinesBlock.CODEC);
        Registry.register(p_304881_, "vault", VaultBlock.CODEC);
        Registry.register(p_304881_, "vine", VineBlock.CODEC);
        Registry.register(p_304881_, "wall_banner", WallBannerBlock.CODEC);
        Registry.register(p_304881_, "wall_hanging_sign", WallHangingSignBlock.CODEC);
        Registry.register(p_304881_, "wall_sign", WallSignBlock.CODEC);
        Registry.register(p_304881_, "wall_skull", WallSkullBlock.CODEC);
        Registry.register(p_304881_, "wall_torch", WallTorchBlock.CODEC);
        Registry.register(p_304881_, "wall", WallBlock.CODEC);
        Registry.register(p_304881_, "waterlily", WaterlilyBlock.CODEC);
        Registry.register(p_304881_, "waterlogged_transparent", WaterloggedTransparentBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_bulb", WeatheringCopperBulbBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_door", WeatheringCopperDoorBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_full", WeatheringCopperFullBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_grate", WeatheringCopperGrateBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_slab", WeatheringCopperSlabBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_stair", WeatheringCopperStairBlock.CODEC);
        Registry.register(p_304881_, "weathering_copper_trap_door", WeatheringCopperTrapDoorBlock.CODEC);
        Registry.register(p_304881_, "web", WebBlock.CODEC);
        Registry.register(p_304881_, "weeping_vines_plant", WeepingVinesPlantBlock.CODEC);
        Registry.register(p_304881_, "weeping_vines", WeepingVinesBlock.CODEC);
        Registry.register(p_304881_, "weighted_pressure_plate", WeightedPressurePlateBlock.CODEC);
        Registry.register(p_304881_, "wet_sponge", WetSpongeBlock.CODEC);
        Registry.register(p_304881_, "wither_rose", WitherRoseBlock.CODEC);
        Registry.register(p_304881_, "wither_skull", WitherSkullBlock.CODEC);
        Registry.register(p_304881_, "wither_wall_skull", WitherWallSkullBlock.CODEC);
        return Registry.register(p_304881_, "wool_carpet", WoolCarpetBlock.CODEC);
    }
}
